import pygame
from pygame.locals import *
pygame.init()
from pgu import gui
import string

MAX_TEXT_LEN = 22

class Chaton(gui.App):
    def __init__(self, width, height, screen, jabber=None):
        self.pos = 0
        self.jabber = jabber
        self.text = gui.area.List(0, 0)

        self.scroll = gui.area.ScrollArea(self.text, width, height, hscrollbar=False)

        self.input = gui.input.Input(width=width)
        self.input.connect(gui.KEYDOWN, self.handle_key)
        self.c = gui.Container(align=-1,valign=-1)
        self.c.add(self.scroll, screen.get_size()[0]-width-10, screen.get_size()[1]-height-60)
        self.c.add(self.input, screen.get_size()[0]-width-10, screen.get_size()[1]-60)
        gui.App.__init__(self)
        self.init(self.c, screen)

    def my_loop(self, event):
        if event and event.type == 2:
            self.input.focus()
            if event.mod != 64:
                self.event(event)
        s = self.screen
        us = self.update(s)
        self.scroll.set_vertical_scroll(65535)
        pygame.display.update(us)

    def handle_key(self, _event):
        if _event.key == K_RETURN and self.input.value != '':
            line = self.input.value.strip()
            if self.jabber:
                self.jabber.send_message(line.decode('latin-1'))
            self.write_line(line, '> ')
            self.input.value = ''

    def write_line(self, line, before=''):
        while len(line) > MAX_TEXT_LEN:
            self.text.add(before+line[:MAX_TEXT_LEN])
            line = line[MAX_TEXT_LEN:]
        self.text.add(before+line[:MAX_TEXT_LEN])
        

if __name__ == '__main__':
    screen = pygame.display.set_mode()
    (width, height) = screen.get_size()
    chat = Chaton(200, 300, screen)
    i = 0
    while True:
        event = pygame.event.wait()
        chat.my_loop(event)
